                        JP Reset                        ;

Print                   PUSH IX                         ;
                        PUSH HL                         ;
                        PUSH DE                         ;
                        PUSH BC                         ;
                        PUSH AF                         ;
                        CP cCLS                         ;
                        JR Z PrintCls                   ;

                        CP cCret                        ;
                        JR Z PrintCret                  ;

                        LD H,$69                        ;
                        LD L,A                          ;
                        LD A,(CurX)                     ;
                        ADD A,(HL)                      ;
                        CALL C PrintHome                ;
                        CALL OutChar                    ;
                        LD A,(CurX)                     ;
                        ADD A,(HL)                      ;
                        LD (CurX),A                     ;
Print_X                 POP AF                          ;
                        POP BC                          ;
                        POP DE                          ;
                        POP HL                          ;
                        POP IX                          ;
                        RET                             ;

PrintCret               CALL PrintHome                  ;
                        JR Print_X                      ;

PrintCls                LD HL,ScreenBase                ;
                        LD (CurY),HL                    ;
                        LD DE,ScreenBase+1              ;
                        LD BC,lScreen                   ;
                        XOR A                           ;
                        OUT ($FE),A                     ;
                        LD (CurX),A                     ;
                        LD (CurpY),A                    ;
                        LD (HL),A                       ;
                        LDIR                            ;
                        LD (HL),Attr_White              ;
                        LD BC,lAttrs-1                  ;
                        LDIR                            ;
                        JR Print_X                      ;

PrintHome               LD A,(CurpY)                    ;
                        INC A                           ;
SetpY                   LD (CurpY),A                    ;
                        AND $1F                         ;
                        PUSH HL                         ;
                        LD L,A                          ;
                        LD H,$00                        ;
                        ADD HL,HL                       ;
                        LD DE,CharYTable                ;
                        ADD HL,DE                       ;
                        LD A,(HL)                       ;
                        INC HL                          ;
                        LD H,(HL)                       ;
                        LD L,A                          ;
                        LD (CurY),HL                    ;
                        XOR A                           ;
                        LD (CurX),A                     ;
                        POP HL                          ;
                        RET                             ;

OutChar                 BIT 7,L                         ;
                        RET NZ                          ;

                        PUSH HL                         ;
                        LD H,0                          ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        LD DE,CharSetPixels -$100       ;
                        ADD HL,DE                       ;
                        PUSH HL                         ;
                        POP IX                          ;
                        LD A,(CurX)                     ;
                        RRCA                            ;
                        RRCA                            ;
                        RRCA                            ;
                        AND $1F                         ;
                        LD DE,(CurY)                    ;
                        OR E                            ;
                        LD E,A                          ;
                        LD A,(CurX)                     ;
                        AND $07                         ;
                        LD C,A                          ;
                        LD B,8                          ;
OC_Lp1                  LD H,(IX)                       ;
                        LD L,0                          ;
                        LD A,C                          ;
                        OR A                            ;
                        JR Z OC_Lp2                     ;

OC_1                    SRL H                           ;
                        RR L                            ;
                        DEC A                           ;
                        JR NZ OC_1                      ;

OC_Lp2                  LD A,(DE)                       ;
                        XOR H                           ;
                        LD (DE),A                       ;
                        INC E                           ;
                        LD A,(DE)                       ;
                        XOR L                           ;
                        LD (DE),A                       ;
                        DEC E                           ;
                        INC IX                          ;
                        INC D                           ;
                        DJNZ OC_Lp1                     ;

                        POP HL                          ;
                        RET                             ;

CharYTable              DEFW $4000,$4020,$4040,$4060,$4080,$40A0,$40C0,$40E0
                        DEFW $4800,$4820,$4840,$4860,$4880,$48A0,$48C0,$48E0
                        DEFW $5000,$5020,$5040,$5060,$5080,$50A0,$50C0,$50E0
                        DEFW $0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000

WaitForSpace            LD A,$7F                        ;
                        IN A,($FE)                      ;
                        BIT 0,A                         ;
                        JR NZ WaitForSpace              ;

                        RET                             ;

PrintStrFollow          EX (SP),HL                      ;
                        PUSH AF                         ;
PSF_Lp                  LD A,(HL)                       ;
                        INC HL                          ;
                        OR A                            ;
                        JR Z PSF_X                      ;

                        CALL Print                      ;
                        JR PSF_Lp                       ;

PSF_X                   POP AF                          ;
                        EX (SP),HL                      ;
                        RET                             ;

InitKbd                 LD HL,KeyCounts                 ;
                        LD DE,KeyCounts+1               ;
                        LD BC,nKeys-1                   ;
                        LD (HL),$09                     ;
                        LDIR                            ;
                        LD HL,200                       ;
                        LD (KeyRepSpeed1),HL            ;
                        LD HL,30                        ;
                        LD (KeyRepSpeed2),HL            ;
                        RET                             ;

ReadKey                 PUSH IX                         ;
                        PUSH HL                         ;
                        PUSH DE                         ;
                        PUSH BC                         ;
                        PUSH AF                         ;
                        EX AF,AF'                       ;
                        PUSH AF                         ;
                        LD HL,KeyCounts                 ;
                        SET 7,(HL)                      ;
                        LD HL,SymbolShift               ;
                        SET 7,(HL)                      ;
                        CALL ReadKeys                   ;
                        DEC A                           ;
                        LD B,A                          ;
                        XOR A                           ;
                        LD HL,KeyCounts                 ;
                        BIT 6,(HL)                      ;
                        JR Z RK_Lp1                     ;

                        ADD A,nKeys                     ;
RK_Lp1                  LD HL,SymbolShift               ;
                        BIT 6,(HL)                      ;
                        JR Z RK_Lp2                     ;

                        ADD A,nKeys*2                   ;
RK_Lp2                  ADD A,B                         ;
                        LD E,A                          ;
                        LD D,$00                        ;
                        LD HL,KTab_0                    ;
                        ADD HL,DE                       ;
                        POP AF                          ;
                        EX AF,AF'                       ;
                        POP AF                          ;
                        LD A,(HL)                       ;
                        POP BC                          ;
                        POP DE                          ;
                        POP HL                          ;
                        POP IX                          ;
                        RET                             ;

ReadKeys                LD A,$01                        ;
                        LD (CursorSpeed),A              ;
                        LD (CursorType),A               ;
ReadKeyLp               CALL CursorInv                  ;
                        CALL ScanKeys                   ;
                        JR NZ RKNewKey                  ;

                        LD A,(CurrKey)                  ;
                        OR A                            ;
                        JR Z ReadKeyLp                  ;

                        LD HL,(CurrKeyAddr)             ;
                        BIT 6,(HL)                      ;
                        JR Z RKCancelOld                ;

                        LD HL,(KeyRepDelay)             ;
                        DEC HL                          ;
                        LD (KeyRepDelay),HL             ;
                        LD A,L                          ;
                        OR H                            ;
                        JR NZ ReadKeyLp                 ;

                        LD HL,(KeyRepSpeed2)            ;
RK1                     LD (KeyRepDelay),HL             ;
                        CALL CursorOff                  ;
                        LD A,(CurrKey)                  ;
                        RET                             ;

RKNewKey                LD (CurrKey),A                  ;
                        LD HL,(KeyRepSpeed1)            ;
                        LD (CurrKeyAddr),IX             ;
                        JR RK1                          ;

RKCancelOld             XOR A                           ;
                        LD (CurrKey),A                  ;
                        JR ReadKeyLp                    ;

CursorOff               LD A,(CursorType)               ;
                        OR A                            ;
                        RET NZ                          ;

                        JP CI_1                         ;

CursorInv               LD A,(CursorSpeed)              ;
                        DEC A                           ;
                        LD (CursorSpeed),A              ;
                        RET NZ                          ;

                        LD A,130                        ;
                        LD (CursorSpeed),A              ;
                        LD A,(CursorType)               ;
                        XOR $01                         ;
                        LD (CursorType),A               ;
CI_1                    LD HL,(CurY)                    ;
                        LD A,H                          ;
                        ADD A,$07                       ;
                        LD H,A                          ;
                        LD A,(CurX)                     ;
                        RRCA                            ;
                        RRCA                            ;
                        RRCA                            ;
                        AND $1F                         ;
                        OR L                            ;
                        LD L,A                          ;
                        LD A,(CurX)                     ;
                        AND $07                         ;
                        LD DE,AttrBuff                  ;
CI_2                    OR A                            ;
                        JR Z CI_3                       ;

                        DEC A                           ;
                        SRL D                           ;
                        RR E                            ;
                        JR CI_2                         ;

CI_3                    LD A,D                          ;
                        XOR (HL)                        ;
                        LD (HL),A                       ;
                        INC L                           ;
                        LD A,E                          ;
                        XOR (HL)                        ;
                        LD (HL),A                       ;
                        RET                             ;

ScanKeys                LD BC,$FFFE                     ;
                        LD HL,KeyCounts                 ;
                        LD E,$00                        ;
ScanKeyLp               DEC B                           ;
                        IN A,(C)                        ;
                        RRA                             ;
                        CALL NC ScanKeyPressed          ;
                        CALL C ScanKeyNotPress          ;
                        INC HL                          ;
                        RRA                             ;
                        CALL NC ScanKeyPressed          ;
                        CALL C ScanKeyNotPress          ;
                        INC HL                          ;
                        RRA                             ;
                        CALL NC ScanKeyPressed          ;
                        CALL C ScanKeyNotPress          ;
                        INC HL                          ;
                        RRA                             ;
                        CALL NC ScanKeyPressed          ;
                        CALL C ScanKeyNotPress          ;
                        INC HL                          ;
                        RRA                             ;
                        CALL NC ScanKeyPressed          ;
                        CALL C ScanKeyNotPress          ;
                        INC HL                          ;
                        SCF                             ;
                        RL B                            ;
                        INC B                           ;
                        JR NZ ScanKeyLp                 ;

                        LD A,E                          ;
                        OR A                            ;
                        RET                             ;

ScanKeyPressed          EX AF,AF'                       ;
                        LD A,(HL)                       ;
                        AND $3F                         ;
                        CP $09                          ;
                        JR Z SKP_1                      ;

                        INC (HL)                        ;
                        EX AF,AF'                       ;
                        RET                             ;

SKP_1                   BIT 6,(HL)                      ;
                        JR NZ SKP_3                     ;

                        BIT 7,(HL)                      ;
                        JR NZ SKP_2                     ;

                        LD A,E                          ;
                        OR A                            ;
                        JR NZ SKP_3                     ;

                        PUSH HL                         ;
                        POP IX                          ;
                        CALL SKNP_2                     ;
                        LD E,A                          ;
SKP_2                   SET 6,(HL)                      ;
SKP_3                   EX AF,AF'                       ;
                        RET                             ;

ScanKeyNotPress         EX AF,AF'                       ;
                        LD A,(HL)                       ;
                        AND $3F                         ;
                        JR Z SKNP_1                     ;

                        DEC (HL)                        ;
                        EX AF,AF'                       ;
                        RET                             ;

SKNP_1                  RES 6,(HL)                      ;
                        EX AF,AF'                       ;
                        RET                             ;

SKNP_2                  PUSH DE                         ;
                        LD DE,CursorType                ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD A,L                          ;
                        ADD HL,DE                       ;
                        POP DE                          ;
                        RET                             ;

KTab_0                  DEFB $00,$7A,$78,$63,$76,$61,$73,$64
                        DEFB $66,$67,$71,$77,$65,$72,$74,$31
                        DEFB $32,$33,$34,$35,$30,$39,$38,$37
                        DEFB $36,$70,$6F,$69,$75,$79,$0D,$6C
                        DEFB $6B,$6A,$68,$20,$00,$6D,$6E,$62

                        DEFB $00,$5A,$58,$43,$56,$41,$53,$44
                        DEFB $46,$47,$51,$57,$45,$52,$54,$21
                        DEFB $40,$23,$24,$25,$08,$29,$28,$27
                        DEFB $26,$50,$4F,$49,$55,$59,$0D,$4C
                        DEFB $4B,$4A,$48,$20,$00,$4D,$4E,$42

                        DEFB $00,$3A,$23,$3F,$2F,$7E,$7C,$27
                        DEFB $7B,$7D,$20,$20,$20,$3C,$3E,$21
                        DEFB $40,$23,$24,$25,$5F,$29,$28,$27
                        DEFB $26,$22,$3B,$20,$5D,$5B,$0D,$3D
                        DEFB $2B,$2D,$5E,$20,$00,$2E,$2C,$2A

                        DEFB $00,$20,$20,$20,$20,$74,$20,$49
                        DEFB $20,$67,$61,$20,$67,$69,$72,$47
                        DEFB $6F,$64,$20,$49,$64,$65,$65,$6E
                        DEFB $20,$73,$65,$6C,$20,$6C,$64,$61
                        DEFB $6D,$20,$6F,$20,$00,$20,$20,$20

Reset                   DI                              ;
                        LD A,R                          ;
                        AND $03                         ;
                        ADD A,A                         ;
                        ADD A,high HighScores           ;
                        LD H,A                          ;
                        LD L,$00                        ;
                        LD DE,HighScores                ;
                        LD BC,$0200                     ;
                        LDIR                            ;
                if enabled bAnalogJoystick
                        LD A,$4A                        ;
                else
                        LD A,$4B                        ;
                endif

                        LD (KeyOrJoystick),A            ;
                        LD (UnkVar11),A                 ;

                if enabled bAnalogJoystick
                        LD A,$05                        ;
                        LD HL,$5961                     ;
                else
                        LD A,$01                        ;
                        LD HL,$5861                     ;
                endif

                        LD (JoystickType),A             ;
                        LD (UnkVar15w),HL               ;

Boot                    LD SP,$0000                     ;
                        DI                              ;
                        LD A,cCLS                       ;
                        CALL Print                      ;
                        CALL InitKbd                    ;
                        CALL ShowMainMenu               ;
                        LD BC,$0000                     ;
DispMain                CALL DM_Pause                   ;
                        LD A,$E7                        ;
                        IN A,($FE)                      ;
                        OR $E0                          ;
                        INC A                           ;
                        JR NZ DM_KeyCheck               ;

                        LD A,$7F                        ;
                        IN A,($FE)                      ;
                        BIT 0,A                         ;
                        JR NZ DM_1                      ;

                        JP StartShowHighScores          ;

DM_1                    DEC BC                          ;
                        LD A,B                          ;
                        OR C                            ;
                        JR NZ DispMain                  ;

                        JP StartShowHighScores          ;

DM_Pause                LD A,$5A                        ;
DMP_Lp                  DEC A                           ;
                        JR NZ DMP_Lp                    ;

                        RET                             ;

DM_KeyCheck             LD A,$F7                        ;
                        IN A,($FE)                      ;
                        BIT 0,A                         ;
                        JP Z PlayGame                   ;

                        BIT 1,A                         ;
                        JP Z MenuInstructs              ;

                        BIT 2,A                         ;
                        JP Z ShowKeyOrJoystickMenu      ;

                        BIT 3,A                         ;
                        JP Z GameOptionsMenu            ;

                        BIT 4,A                         ;
                        JP Z LoadHSMenu                 ;

                        LD A,$EF                        ;
                        IN A,($FE)                      ;
                        BIT 0,A                         ;
                        JR Z DispMain                   ;

                        BIT 1,A                         ;
                        BIT 3,A                         ;
                        JP Z AttemptPrint               ;

                        BIT 4,A                         ;
                        JP Z SaveHSMenu                 ;

                        JR DispMain                     ;

GameOptionsMenu         LD A,cCLS                       ;
                        CALL Print                      ;
                        LD HL,AttrBase                  ;
                        LD DE,AT_MainMenu               ;
                        CALL SetTheAttrs                ;
                        CALL PrintStrFollow             ;
                        DEFB $86,$86,$82,"Game Options",cCret,cCret
                        DEFB " 1  Change Game Format",cCret,cCret
                        DEFB " 2  Change Skill Factors",cCret,cCret,cCret
                        DEFB " 3  Change Enemy Missiles",cCret,cCret
                        DEFB " 4  Change Sound Effects",cCret,cCret,cCret
                        DEFB " 5  Change Display Format",cCret,cCret,cCret,cCret,cCret,cCret,cCret
                        DEFB " 8  Return to main menu",$00

                        CALL WaitWhileKeyPressed        ;

GOM_Lp                  LD A,$F7                        ;
                        IN A,($FE)                      ;
                        BIT 0,A                         ;
                        JP Z GameVarsMenu               ;

                        BIT 1,A                         ;
                        JP Z SkillLevelMenu             ;

                        BIT 2,A                         ;
                        JP Z MissileVarsMenu            ;

                        BIT 3,A                         ;
                        JP Z SoundVarsMenu              ;

                        BIT 4,A                         ;
                        JP Z DisplayVarsMenu            ;

                        LD A,$EF                        ;
                        IN A,($FE)                      ;
                        BIT 4,A                         ;
                        BIT 2,A                         ;
                        JP Z Boot                       ;

                        JR GOM_Lp                       ;


                        JP Boot                         ;

GameVarsMenu            LD A,cCLS                       ;
                        CALL Print                      ;
                        LD HL,AttrBase                  ;
                        LD DE,AT_GameVarMenu            ;
                        CALL SetTheAttrs                ;
                        CALL PrintStrFollow             ;
                        DEFB $86,$86,$82,"Game Variants",cCret,cCret
                        DEFB " 1  Normal game",cCret,cCret
                        DEFB " 2  Normal , but no planetary shields",cCret,cCret
                        DEFB " 3  Unlimited numbers of enemy ships",cCret,cCret
                        DEFB " 4  No planets",cCret,cCret,cCret,cCret
                        DEFB " 6  Something else . . . . ",cCret,cCret,cCret,cCret
                        DEFB " 8  Return to main menu",cCret,cCret
                        DEFB " 9  Return to options menu",$00

                        CALL WaitWhileKeyPressed        ;
                        LD HL,$0001                     ;
                        LD (MenuFlashTmr),HL            ;
                        LD A,$FF                        ;
                        LD (MenuFlashState),A           ;
                        LD IX,(optVar9w)                ;
                        LD A,(optGameFormat)            ;
                        LD D,A                          ;
                        LD A,(optVar14)                 ;
                        LD E,A                          ;
GVM_Lp                  CALL MenuHouseKeep              ;
                        LD A,$EF                        ;
                        IN A,($FE)                      ;
                        RRCA                            ;
                        RRCA                            ;
                        JR NC GVM_1                     ;

                        RRCA                            ;
                        JR NC GVM_2                     ;

                        LD A,$F7                        ;
                        IN A,($FE)                      ;
                        RRCA                            ;
                        LD HL,$5843                     ;
                        LD BC,$0046                     ;
                        CALL NC MenuSelectOpt           ;
                        RRCA                            ;
                        LD HL,$5883                     ;
                        LD BC,$0145                     ;
                        CALL NC MenuSelectOpt           ;
                        RRCA                            ;
                        LD HL,$58C3                     ;
                        LD BC,$0207                     ;
                        CALL NC MenuSelectOpt           ;
                        RRCA                            ;
                        LD HL,$5903                     ;
                        LD BC,$0344                     ;
                        CALL NC MenuSelectOpt           ;
                        LD A,$EF                        ;
                        IN A,($FE)                      ;
                        BIT 4,A                         ;
                        LD HL,$5983                     ;
                        LD BC,$0446                     ;
                        CALL Z MenuSelectOpt            ;
                        JR GVM_Lp                       ;

GVM_1                   LD A,D                          ;
                        LD (optGameFormat),A            ;
                        LD A,E                          ;
                        LD (optVar14),A                 ;
                        LD (optVar9w),IX                ;
                        JP GameOptionsMenu              ;

GVM_2                   LD A,D                          ;
                        LD (optGameFormat),A            ;
                        LD A,E                          ;
                        LD (optVar14),A                 ;
                        LD (optVar9w),IX                ;
                        JP Boot                         ;

SkillLevelMenu          LD A,cCLS                       ;
                        CALL Print                      ;
                        LD HL,AttrBase                  ;
                        LD DE,AT_SkillMenu              ;
                        CALL SetTheAttrs                ;
                        CALL PrintStrFollow             ;
                        DEFB $86,$86,$82,"Skill levels",cCret,cCret
                        DEFB " 1  Easy",cCret,cCret
                        DEFB " 2  Fairly easy",cCret,cCret," 3  Normal",cCret,cCret
                        DEFB " 4  Fairly difficult",cCret,cCret
                        DEFB " 5  Difficult",cCret,cCret
                        DEFB " 6  Pretty damn devastating !",cCret,cCret,cCret,cCret
                        DEFB " 8  Return to main menu",cCret,cCret
                        DEFB " 9  Return to options menu",$00

                        CALL WaitWhileKeyPressed        ;
                        LD HL,$0001                     ;
                        LD (MenuFlashTmr),HL            ;
                        LD A,$FF                        ;
                        LD (MenuFlashState),A           ;
                        LD IX,(optVar8w)                ;
                        LD A,(optSkillLevel)            ;
                        LD D,A                          ;
                        LD A,(optVar13)                 ;
                        LD E,A                          ;
SVM_Lp                  CALL MenuHouseKeep              ;
                        LD A,$EF                        ;
                        IN A,($FE)                      ;
                        RRCA                            ;
                        RRCA                            ;
                        JR NC SVM_1                     ;

                        RRCA                            ;
                        JR NC SVM_2                     ;

                        LD A,$F7                        ;
                        IN A,($FE)                      ;
                        RRCA                            ;
                        LD HL,$5843                     ;
                        LD BC,$0046                     ;
                        CALL NC MenuSelectOpt           ;
                        RRCA                            ;
                        LD HL,$5883                     ;
                        LD BC,$0145                     ;
                        CALL NC MenuSelectOpt           ;
                        RRCA                            ;
                        LD HL,$58C3                     ;
                        LD BC,$0207                     ;
                        CALL NC MenuSelectOpt           ;
                        RRCA                            ;
                        LD HL,$5903                     ;
                        LD BC,$0344                     ;
                        CALL NC MenuSelectOpt           ;
                        RRCA                            ;
                        LD HL,$5943                     ;
                        LD BC,$0445                     ;
                        CALL NC MenuSelectOpt           ;
                        LD A,$EF                        ;
                        IN A,($FE)                      ;
                        BIT 4,A                         ;
                        LD HL,$5983                     ;
                        LD BC,$0546                     ;
                        CALL Z MenuSelectOpt            ;
                        JR SVM_Lp                       ;

SVM_1                   LD A,D                          ;
                        LD (optSkillLevel),A            ;
                        LD A,E                          ;
                        LD (optVar13),A                 ;
                        LD (optVar8w),IX                ;
                        JP GameOptionsMenu              ;

SVM_2                   LD A,D                          ;
                        LD (optSkillLevel),A            ;
                        LD A,E                          ;
                        LD (optVar13),A                 ;
                        LD (optVar8w),IX                ;
                        JP Boot                         ;

MissileVarsMenu         LD A,cCLS                       ;
                        CALL Print                      ;
                        LD HL,AttrBase                  ;
                        LD DE,AT_SkillMenu              ;
                        CALL SetTheAttrs                ;
                        CALL PrintStrFollow             ;
                        DEFB $86,$86,$82,"Missile options",cCret,cCret
                        DEFB " 1  None",cCret,cCret
                        DEFB " 2  Slow and inaccurate",cCret,cCret
                        DEFB " 3  Fast but inaccurate",cCret,cCret
                        DEFB " 4  Slow and accurate",cCret,cCret
                        DEFB " 5  Fast and accurate",cCret,cCret
                        DEFB " 6  Pretty damn devastating !",cCret,cCret,cCret,cCret
                        DEFB " 8  Return to main menu",cCret,cCret
                        DEFB " 9  Return to options menu",$00
                        CALL WaitWhileKeyPressed        ;
                        LD HL,$0001                     ;
                        LD (MenuFlashTmr),HL            ;
                        LD A,$FF                        ;
                        LD (MenuFlashState),A           ;
                        LD IX,(optVar7w)                ;
                        LD A,(optMissileType)           ;
                        LD D,A                          ;
                        LD A,(optVar12)                 ;
                        LD E,A                          ;
MVM_Lp                  CALL MenuHouseKeep              ;
                        LD A,$EF                        ;
                        IN A,($FE)                      ;
                        RRCA                            ;
                        RRCA                            ;
                        JR NC MVM_1                     ;

                        RRCA                            ;
                        JR NC MVM_2                     ;

                        LD A,$F7                        ;
                        IN A,($FE)                      ;
                        RRCA                            ;
                        LD HL,$5843                     ;
                        LD BC,$0046                     ;
                        CALL NC MenuSelectOpt           ;
                        RRCA                            ;
                        LD HL,$5883                     ;
                        LD BC,$0145                     ;
                        CALL NC MenuSelectOpt           ;
                        RRCA                            ;
                        LD HL,$58C3                     ;
                        LD BC,$0307                     ;
                        CALL NC MenuSelectOpt           ;
                        RRCA                            ;
                        LD HL,$5903                     ;
                        LD BC,$0544                     ;
                        CALL NC MenuSelectOpt           ;
                        RRCA                            ;
                        LD HL,$5943                     ;
                        LD BC,$0745                     ;
                        CALL NC MenuSelectOpt           ;
                        LD A,$EF                        ;
                        IN A,($FE)                      ;
                        BIT 4,A                         ;
                        LD HL,$5983                     ;
                        LD BC,$0F46                     ;
                        CALL Z MenuSelectOpt            ;
                        JR MVM_Lp                       ;

MVM_1                   LD A,D                          ;
                        LD (optMissileType),A           ;
                        LD A,E                          ;
                        LD (optVar12),A                 ;
                        LD (optVar7w),IX                ;
                        JP GameOptionsMenu              ;

MVM_2                   LD A,D                          ;
                        LD (optMissileType),A           ;
                        LD A,E                          ;
                        LD (optVar12),A                 ;
                        LD (optVar7w),IX                ;
                        JP Boot                         ;

SoundVarsMenu           LD A,cCLS                       ;
                        CALL Print                      ;
                        LD HL,AttrBase                  ;
                        LD DE,AT_SkillMenu              ;
                        CALL SetTheAttrs                ;
                        CALL PrintStrFollow             ;
                        DEFB $86,$86,$82,"Sounds Selected",cCret,cCret
                        DEFB " 1  No noise",cCret,cCret
                        DEFB " 2  Your firing only",cCret,cCret
                        DEFB " 3  Explosions only",cCret,cCret
                        DEFB " 4  Firing and explosions",cCret,cCret
                        DEFB " 5  All sounds except hyperspace",cCret,cCret
                        DEFB " 6  Full sound",cCret,cCret,cCret,cCret
                        DEFB " 8  Return to main menu",cCret,cCret
                        DEFB " 9  Return to options menu",$00

                        CALL WaitWhileKeyPressed        ;
                        LD HL,$0001                     ;
                        LD (MenuFlashTmr),HL            ;
                        LD A,$FF                        ;
                        LD (MenuFlashState),A           ;
                        LD IX,(optVar6w)                ;
                        LD A,(optNoises)                ;
                        LD D,A                          ;
                        LD A,(optVar11)                 ;
                        LD E,A                          ;
SNDVM_Lp                CALL MenuHouseKeep              ;
                        LD A,$EF                        ;
                        IN A,($FE)                      ;
                        RRCA                            ;
                        RRCA                            ;
                        JR NC SNDVM_1                   ;

                        RRCA                            ;
                        JR NC SNDVM_2                   ;

                        LD A,$F7                        ;
                        IN A,($FE)                      ;
                        RRCA                            ;
                        LD HL,$5843                     ;
                        LD BC,$0046                     ;
                        CALL NC MenuSelectOpt           ;
                        RRCA                            ;
                        LD HL,$5883                     ;
                        LD BC,$0145                     ;
                        CALL NC MenuSelectOpt           ;
                        RRCA                            ;
                        LD HL,$58C3                     ;
                        LD BC,$0207                     ;
                        CALL NC MenuSelectOpt           ;
                        RRCA                            ;
                        LD HL,$5903                     ;
                        LD BC,$0344                     ;
                        CALL NC MenuSelectOpt           ;
                        RRCA                            ;
                        LD HL,$5943                     ;
                        LD BC,$0745                     ;
                        CALL NC MenuSelectOpt           ;
                        LD A,$EF                        ;
                        IN A,($FE)                      ;
                        BIT 4,A                         ;
                        LD HL,$5983                     ;
                        LD BC,$0F46                     ;
                        CALL Z MenuSelectOpt            ;
                        JR SNDVM_Lp                     ;

SNDVM_1                 LD A,D                          ;
                        LD (optNoises),A                ;
                        LD A,E                          ;
                        LD (optVar11),A                 ;
                        LD (optVar6w),IX                ;
                        JP GameOptionsMenu              ;

SNDVM_2                 LD A,D                          ;
                        LD (optNoises),A                ;
                        LD A,E                          ;
                        LD (optVar11),A                 ;
                        LD (optVar6w),IX                ;
                        JP Boot                         ;

DisplayVarsMenu         LD A,cCLS                       ;
                        CALL Print                      ;
                        LD HL,AttrBase                  ;
                        LD DE,AT_GameFormat             ;
                        CALL SetTheAttrs                ;
                        CALL PrintStrFollow             ;
                        DEFB $86,$86,$82,"Display Format",cCret,cCret
                        DEFB " 1  Normal",cCret,cCret
                        DEFB " 2  Pretty Graphic Mode",cCret,cCret
                        DEFB " 3  Slimline Tonic",cCret,cCret
                        DEFB " 4  Wide-Angle Mode",cCret,cCret,cCret,cCret,cCret,cCret,cCret,cCret
                        DEFB " 8  Return to main menu",cCret,cCret
                        DEFB " 9  Return to options menu",$00

                        CALL WaitWhileKeyPressed        ;
                        LD HL,$0001                     ;
                        LD (MenuFlashTmr),HL            ;
                        LD A,$FF                        ;
                        LD (MenuFlashState),A           ;
                        LD IX,(optVar5w)                ;
                        LD A,(optVarDisplayMode)        ;
                        LD D,A                          ;
                        LD A,(optVar10)                 ;
                        LD E,A                          ;
DVM_Lp                  CALL MenuHouseKeep              ;
                        LD A,$EF                        ;
                        IN A,($FE)                      ;
                        RRCA                            ;
                        RRCA                            ;
                        JR NC DVM_1                     ;

                        RRCA                            ;
                        JR NC DVM_2                     ;

                        LD A,$F7                        ;
                        IN A,($FE)                      ;
                        RRCA                            ;
                        LD HL,$5843                     ;
                        LD BC,$0046                     ;
                        CALL NC MenuSelectOpt           ;
                        RRCA                            ;
                        LD HL,$5883                     ;
                        LD BC,$0145                     ;
                        CALL NC MenuSelectOpt           ;
                        RRCA                            ;
                        LD HL,$58C3                     ;
                        LD BC,$0207                     ;
                        CALL NC MenuSelectOpt           ;
                        RRCA                            ;
                        LD HL,$5903                     ;
                        LD BC,$0344                     ;
                        CALL NC MenuSelectOpt           ;
                        JR DVM_Lp                       ;

MenuSelectOpt           PUSH AF                         ;
                        PUSH HL                         ;
                        LD A,D                          ;
                        CP B                            ;
                        JR Z MSO_X                      ;

                        LD D,B                          ;
                        CALL MHK_Set                    ;
                        LD E,C                          ;
MSO_X                   POP IX                          ;
                        POP AF                          ;
                        RET                             ;

MenuHouseKeep           LD HL,(MenuFlashTmr)            ;
                        DEC HL                          ;
                        LD (MenuFlashTmr),HL            ;
                        LD A,L                          ;
                        OR H                            ;
                        JP NZ JSM_Delay                 ;

                        LD HL,$012C                     ;
                        LD (MenuFlashTmr),HL            ;
                        LD A,(MenuFlashState)           ;
                        XOR $FF                         ;
                        LD (MenuFlashState),A           ;
                        JR NZ MHK_Set                   ;

                        PUSH IX                         ;
                        POP HL                          ;
                        LD B,$1E                        ;
MHK_ClrLp               LD (HL),$00                     ;
                        INC L                           ;
                        DJNZ MHK_ClrLp                  ;

                        RET                             ;

MHK_Set                 PUSH IX                         ;
                        POP HL                          ;
                        LD B,$1E                        ;
MHK_SetLp               LD (HL),E                       ;
                        INC L                           ;
                        DJNZ MHK_SetLp                  ;

                        RET                             ;

DVM_1                   LD A,D                          ;
                        LD (optVarDisplayMode),A        ;
                        LD A,E                          ;
                        LD (optVar10),A                 ;
                        LD (optVar5w),IX                ;
                        JP GameOptionsMenu              ;

DVM_2                   LD A,D                          ;
                        LD (optVarDisplayMode),A        ;
                        LD A,E                          ;
                        LD (optVar10),A                 ;
                        LD (optVar5w),IX                ;
                        JP Boot                         ;

                        CALL WaitForSpace               ;
                        JP Boot                         ;

                        CALL WaitForSpace               ;
                        JP Boot                         ;

WaitWhileKeyPressed     LD A,$E7                        ;
                        IN A,($FE)                      ;
                        OR $E0                          ;
                        INC A                           ;
                        JR NZ WaitWhileKeyPressed       ;

                        RET                             ;

MenuInstructs           LD A,cCLS                       ;
                        CALL Print                      ;
                        LD HL,AttrBase                  ;
                        LD DE,AT_Instructions           ;
                        CALL SetTheAttrs                ;
                        CALL PrintStrFollow             ;
                        DEFB $86,$86,$82,"Instructions",cCret,cCret,cCret,cCret
                        DEFB "Fly around the universe",cCret,cCret
                        DEFB "If it moves shoot it",cCret,cCret
                        DEFB "If it doesn't shoot it anyway",cCret,cCret
                        DEFB "If it's square fly through it !",cCret,cCret,cCret,cCret,cCret,cCret,cCret,cCret,cCret,cCret,cCret
                        DEFB "oh - while you're at it ... read the inlay !",cCret,cCret
                        DEFB "Press SPACE to continue .",$00

                        CALL WaitForSpace               ;
                        JP Boot                         ;

ShowKeyOrJoystickMenu   LD A,(KeyOrJoystick)            ;
                        CP $4A                          ;
                        JP Z JoystickMenu               ;

ShowControls            LD A,$4B                        ;
                        LD (KeyOrJoystick),A            ;
                        LD A,cCLS                       ;
                        CALL Print                      ;
                        LD HL,AttrBase                  ;
                        LD DE,AT_Controls               ;
                        CALL SetTheAttrs                ;
                        CALL PrintStrFollow             ;
                        DEFB $86,$86,$82,"Present controls",cCret,cCret
                        DEFB "1 Left",cCret,cCret
                        DEFB "2 Right",cCret,cCret
                        DEFB "3 Up",cCret,cCret
                        DEFB "4 Down",cCret,cCret
                        DEFB "5 Accelerate",cCret,cCret
                        DEFB "6 Deccelerate",cCret,cCret
                        DEFB "7 Fire",cCret,cCret,cCret
                        DEFB "8 Return to main menu  9 Select a joystick",cCret,cCret
                        DEFB " Press a number from 1 to 7 to select the",cCret
                        DEFB "control you want to change then type all",cCret
                        DEFB "the keys you want for that control .",cCret
                        DEFB "When you have finished with it then press",cCret
                        DEFB "another number to continue .",$00

ShowContLp              LD HL,UDK_Left                  ;
                        LD A,$02                        ;
SC_Lp1                  PUSH HL                         ;
                        PUSH AF                         ;
                        CALL SetpY                      ;
                        PUSH HL                         ;
                        CALL SC_Unk3                    ;
                        POP HL                          ;
                        LD A,$54                        ;
                        LD (CurX),A                     ;
SC_Lp2                  LD A,(HL)                       ;
                        INC HL                          ;
                        CP $40                          ;
                        JR NC SC_1                      ;

                        CALL SC_Unk5                    ;
                        CALL Print80                    ;
                        JR SC_Lp2                       ;

SC_1                    POP AF                          ;
                        POP HL                          ;
                        LD DE,$0010                     ;
                        ADD HL,DE                       ;
                        ADD A,$02                       ;
                        CP $10                          ;
                        JR NZ SC_Lp1                    ;

                        CALL WaitWhileKeyPressed        ;
SC_2                    LD A,$F7                        ;
                        IN A,($FE)                      ;
                        RRCA                            ;
                        LD B,$02                        ;
                        LD DE,UDK_Left                  ;
                        JR NC SC_3                      ;

                        RRCA                            ;
                        LD B,$04                        ;
                        LD DE,UDK_Right                 ;
                        JR NC SC_3                      ;

                        RRCA                            ;
                        LD B,$06                        ;
                        LD DE,UDK_Up                    ;
                        JR NC SC_3                      ;

                        RRCA                            ;
                        LD B,$08                        ;
                        LD DE,UDK_Down                  ;
                        JR NC SC_3                      ;

                        RRCA                            ;
                        LD B,$0A                        ;
                        LD DE,UDK_Acc                   ;
                        JR NC SC_3                      ;

                        LD A,$EF                        ;
                        IN A,($FE)                      ;
                        RRCA                            ;
                        JR NC SC_2                      ;

                        RRCA                            ;
                        JP NC JoystickMenu              ;

                        RRCA                            ;
                        JP NC Boot                      ;

                        RRCA                            ;
                        LD B,$0E                        ;
                        LD DE,UDK_Fire                  ;
                        JR NC SC_3                      ;

                        RRCA                            ;
                        LD B,$0C                        ;
                        LD DE,UDK_Decc                  ;
                        JR C SC_2                       ;

SC_3                    PUSH DE                         ;
                        POP IX                          ;
                        LD (unkVar6w),DE                ;
                        LD A,B                          ;
                        LD (unkVar1b),A                 ;
                        CALL SetpY                      ;
                        LD A,$54                        ;
                        LD (CurX),A                     ;
                        LD (IX),$40                     ;
                        CALL SC_Unk3                    ;

                        LD A,(unkVar1b)                 ;
                        LD L,A                          ;
                        LD H,$00                        ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;

                        LD A,high AttrBase              ;
                        ADD A,H                         ;
                        LD H,A                          ;
                        INC L                           ;
                        LD (unkVar5w),HL                ;

                        LD HL,$0001                     ;
                        LD (MenuFlashTmr),HL            ;

                        LD A,$FF                        ;
                        LD (MenuFlashState),A           ;

                        LD HL,UnkBuff40                 ;
                        LD DE,UnkBuff40+1               ;
                        LD BC,$000F                     ;
                        LD (HL),$00                     ;
                        LDIR                            ;
                        LD BC,$000A                     ;
                        LD (HL),$01                     ;
                        LDIR                            ;
                        LD BC,$000F                     ;
                        LD (HL),$00                     ;
                        LDIR                            ;
SC_4                    LD B,$32                        ;
SC_Lp3                  PUSH BC                         ;
                        CALL MenuFlash                  ;
                        CALL JSM_Delay                  ;
                        POP BC                          ;
                        LD A,$E7                        ;
                        IN A,($FE)                      ;
                        OR $E0                          ;
                        INC A                           ;
                        JR NZ SC_4                      ;

                        DJNZ SC_Lp3                     ;

SC_5                    LD A,$E7                        ;
                        IN A,($FE)                      ;
                        OR $E0                          ;
                        INC A                           ;
                        JR NZ SC_Unk4                   ;

                        CALL MenuFlash                  ;
                        LD HL,UnkBuff40                 ;
                        LD BC,$FEFE                     ;
                        LD DE,$0100                     ;
SC_Lp4                  IN A,(C)                        ;
                        CALL SC_Unk2                    ;
                        CALL SC_Unk2                    ;
                        CALL SC_Unk2                    ;
                        CALL SC_Unk2                    ;
                        CALL SC_Unk2                    ;
                        RLC B                           ;
                        JR C SC_Lp4                     ;

                        LD A,E                          ;
                        OR A                            ;
                        JR Z SC_5                       ;

                        LD A,IXL                        ;
                        AND $0F                         ;
                        CP $0F                          ;
                        JR Z SC_5                       ;

                        DEC E                           ;
                        LD (IX),E                       ;
                        INC IX                          ;
                        LD A,E                          ;
                        CALL SC_Unk5                    ;
                        CALL Print80                    ;
                        JR SC_5                         ;

SC_Unk2                 RRCA                            ;
                        PUSH AF                         ;
                        JR C SC_Unk2a                   ;

                        LD A,(HL)                       ;
                        OR A                            ;
                        JR NZ SC_Unk2a                  ;

                        LD A,E                          ;
                        OR A                            ;
                        JR NZ SC_Unk2a                  ;

                        LD (HL),$FF                     ;
                        LD E,D                          ;
SC_Unk2a                POP AF                          ;
                        INC D                           ;
                        INC HL                          ;
                        RET                             ;

SC_Unk3                 LD B,$08                        ;
                        LD HL,(CurY)                    ;
                        LD DE,$000A                     ;
                        ADD HL,DE                       ;
SC_Unk3a                PUSH HL                         ;
                        PUSH BC                         ;
                        LD B,$16                        ;
SC_Unk3_Lp              LD (HL),$00                     ;
                        INC L                           ;
                        DJNZ SC_Unk3_Lp                 ;

                        POP BC                          ;
                        POP HL                          ;
                        INC H                           ;
                        DJNZ SC_Unk3a                   ;

                        RET                             ;


SC_Unk4                 CALL SomeSortOfInit             ;
                        LD (IX),$FF                     ;
                        LD HL,(unkVar6w)                ;
                        PUSH IX                         ;
                        POP DE                          ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        JP NZ SC_2                      ;

                        LD HL,$0500                     ;
                        ADD HL,DE                       ;
                        LD BC,$0010                     ;
                        LDIR                            ;
                        JP ShowContLp                   ;

SC_Unk5                 PUSH HL                         ;
                        LD HL,UnkVector                 ;
                        INC A                           ;
SC_Unk5a                DEC A                           ;
                        JR Z SC_PrintLp                 ;

SC_Unk5b                BIT 7,(HL)                      ;
                        INC HL                          ;
                        JR NZ SC_Unk5b                  ;

                        JR SC_Unk5a                     ;

SC_PrintLp              LD A,(HL)                       ;
                        AND $7F                         ;
                        CALL Print                      ;
                        BIT 7,(HL)                      ;
                        INC HL                          ;
                        JR NZ SC_PrintLp                ;

                        POP HL                          ;
                        RET                             ;

MenuFlash               LD HL,(MenuFlashTmr)            ;
                        DEC HL                          ;
                        LD (MenuFlashTmr),HL            ;
                        LD A,L                          ;
                        OR H                            ;
                        RET NZ                          ;

                        LD HL,$012C                     ;
                        LD (MenuFlashTmr),HL            ;
                        LD A,(MenuFlashState)           ;
                        XOR $FF                         ;
                        LD (MenuFlashState),A           ;
                        JR NZ SomeSortOfInit            ;

                        LD HL,(unkVar5w)                ;
                        LD B,$09                        ;
MF_Lp                   LD (HL),$00                     ;
                        INC L                           ;
                        DJNZ MF_Lp                      ;

                        RET                             ;

SomeSortOfInit          LD HL,(unkVar5w)                ;
                        LD B,$09                        ;
SSOI_Lp                 LD (HL),$46                     ;
                        INC L                           ;
                        DJNZ SSOI_Lp                    ;

                        RET                             ;

UnkVector               JP $5A53                        ;


PossKeyNames            DEFB "XCVASDFGQWERT1234509876POIUY",$C5,$CE
                        DEFB "TLKJH",$D3,"P",$D3,"SMNB"

JoystickMenu            LD A,$4A                        ;
                        LD (KeyOrJoystick),A            ;
                        LD A,cCLS                       ;
                        CALL Print                      ;
                        LD HL,AttrBase                  ;
                        LD DE,AT_Joysticks              ;
                        CALL SetTheAttrs                ;
                        CALL PrintStrFollow             ;
                        DEFB $86,$86,$83,"Joystick Menu",cCret,cCret,cCret
                        DEFB "1 Kempston",cCret,cCret
                        DEFB "2 Fuller Box",cCret,cCret
                        DEFB "3 Protek ( any cursor joystick )",cCret,cCret
                        DEFB "4 Sinclair Interface 2",cCret,cCret
                        DEFB "5 Analogue Joystick",cCret,cCret,cCret
                        DEFB "8 Return to main menu  9 Select the keyboard",cCret,cCret,cCret
                        DEFB " Please note that even when you select",cCret
                        DEFB "a joystick the keyboard is still used for",cCret
                        DEFB "accelerate & deccelerate .",cCret,cCret
                        DEFB " If you have a programmable joystick then",cCret
                        DEFB "select the Sinclair and define yours to be",cCret
                        DEFB "6 = Left 7 = Right 9 = Up 8 = Down 0 = Fire",$00
                        DEFB "!",$01,$00

                        LD (MenuFlashTmr),HL            ;
                        LD A,$FF                        ;
                        LD (MenuFlashState),A           ;
JSM_Lp                  CALL JSM_House                  ;
                        LD A,$EF                        ;
                        IN A,($FE)                      ;
                        RRCA                            ;
                        RRCA                            ;
                        JP NC ShowControls              ;

                        RRCA                            ;
                        JP NC Boot                      ;

                        LD A,$F7                        ;
                        IN A,($FE)                      ;
                        RRCA                            ;
                        LD HL,$5861                     ;
                        LD B,$01                        ;
                        JR NC JSM_Lp2                   ;

                        RRCA                            ;
                        LD HL,$58A1                     ;
                        LD B,$02                        ;
                        JR NC JSM_Lp2                   ;

                        RRCA                            ;
                        LD HL,$58E1                     ;
                        LD B,$03                        ;
                        JR NC JSM_Lp2                   ;

                        RRCA                            ;
                        LD HL,$5921                     ;
                        LD B,$04                        ;
                        JR NC JSM_Lp2                   ;

                        RRCA                            ;
                        LD HL,$5961                     ;
                        LD B,$05                        ;
                        JR C JSM_Lp                     ;

JSM_Lp2                 PUSH HL                         ;
                        LD A,(JoystickType)             ;
                        CP B                            ;
                        JR Z JSM_1                      ;

                        LD A,B                          ;
                        LD (JoystickType),A             ;
                        CALL JS_Unk1                    ;
JSM_1                   POP HL                          ;
                        LD (UnkVar15w),HL               ;
                        JR JSM_Lp                       ;

JSM_House               LD HL,(MenuFlashTmr)            ;
                        DEC HL                          ;
                        LD (MenuFlashTmr),HL            ;
                        LD A,L                          ;
                        OR H                            ;
                        JR NZ JSM_Delay                 ;

                        LD HL,$012C                     ;
                        LD (MenuFlashTmr),HL            ;
                        LD A,(MenuFlashState)           ;
                        XOR $FF                         ;
                        LD (MenuFlashState),A           ;
                        JR NZ JS_Unk1                   ;

                        LD HL,(UnkVar15w)               ;
                        LD B,$1E                        ;
JSMH_Lp                 LD (HL),$00                     ;
                        INC L                           ;
                        DJNZ JSMH_Lp                    ;

                        RET                             ;

JS_Unk1                 LD HL,(UnkVar15w)               ;
                        LD B,$1E                        ;
JS_UnkLp1               LD (HL),$46                     ;
                        INC L                           ;
                        DJNZ JS_UnkLp1                  ;

                        RET                             ;

JSM_Delay               LD B,$50                        ;
JSM_DelayLp             PUSH IX                         ;
                        POP IX                          ;
                        DJNZ JSM_DelayLp                ;

                        RET                             ;

LoadHSMenu              LD A,cCLS                       ;
                        CALL Print                      ;
                        LD HL,AttrBase                  ;
                        LD DE,AT_LoadHS                 ;
                        CALL SetTheAttrs                ;
                        CALL PrintStrFollow             ;
                        DEFB $86,$86,"Loading The Hi-Scores",cCret,cCret,cCret
                        DEFB "1 Load the High Scores etc from tape .",cCret,cCret,cCret
                        DEFB "8 Return to the main menu .",cCret,cCret,cCret
                        DEFB " If you want to load the high score tables",cCret
                        DEFB "and game options then connect up your",cCret
                        DEFB "cassette recorder ready for loading and",cCret
                        DEFB "find the start of the file you want to load .",cCret
                        DEFB " Then press ",$22,"1",$22," .",$00

LoadHSMenuLp            LD A,$EF                        ;
                        IN A,($FE)                      ;
                        BIT 2,A                         ;
                        JP Z Boot                       ;

                        LD A,$F7                        ;
                        IN A,($FE)                      ;
                        BIT 0,A                         ;
                        JR NZ LoadHSMenuLp              ;

                        CALL PrintStrFollow             ;
                        DEFB cCret,cCret," To break out of the load you press ENTER",$00

L7E04                   LD IX,$F000                     ;
                        LD DE,$0C00                     ;
                        LD A,$42                        ;
                        CALL Unk11                      ;
                        JR NC L7E04                     ;

                        LD HL,$F000                     ;
                        LD DE,HighScores                ;
                        LD BC,$0C00                     ;
                        LDIR                            ;
                        JP Boot                         ;

SaveHSMenu              LD A,cCLS                       ;
                        CALL Print                      ;
                        LD HL,AttrBase                  ;
                        LD DE,AT_SaveHS                 ;
                        CALL SetTheAttrs                ;
                        CALL PrintStrFollow             ;
                        DEFB $86,$86,"Saving The Hi-Scores",cCret,cCret,cCret
                        DEFB "1 Save the current High Scores etc .",cCret,cCret,cCret
                        DEFB "8 Return to the main menu .",cCret,cCret,cCret
                        DEFB " If you want to save the high score tables",cCret
                        DEFB "and game options then connect up your",cCret
                        DEFB "cassette recorder ready for saving and",cCret
                        DEFB "start the tape . Then press ",$22,"1",$22," .",cCret
                        DEFB " This save does not have file names so I",cCret
                        DEFB "suggest you record each new file on the",cCret
                        DEFB "start of a new blank tape .",cCret,cCret
                        DEFB " DO NOT RECORD ON THE DARK STAR TAPE !",cCret,cCret
                        DEFB " There is another ( free ! ) programme",cCret
                        DEFB " on the end of the Dark Star tape .",cCret,cCret
                        DEFB $86,"{ If you can make it go ! }",$00

SaveHSMenuLp            LD A,$EF                        ;
                        IN A,($FE)                      ;
                        BIT 2,A                         ;
                        JP Z Boot                       ;

                        LD A,$F7                        ;
                        IN A,($FE)                      ;
                        BIT 0,A                         ;
                        JR NZ SaveHSMenuLp              ;

                        LD IX,HighScores                ;
                        LD A,$42                        ;
                        LD DE,$0C00                     ;
                        CALL Unk13                      ;
                        JP Boot                         ;

AttemptPrint            LD A,cCLS                       ;
                        CALL Print                      ;
                        LD B,$00                        ;
PrintExistsTest         IN A,($FB)                      ;
                        ADD A,A                         ;
                        JP M PrinterFail                ;

                        DJNZ PrintExistsTest            ;

                        JP PrinterMenu                  ;

PrinterFail             LD HL,AttrBase                  ;
                        LD DE,AT_PrinterFail            ;
                        CALL SetTheAttrs                ;
                        CALL PrintStrFollow             ;
                        DEFB cCret,cCret,cCret,cCret
                        DEFB " Look sunshine ... seeing as how you aint got",cCret,cCret
                        DEFB "no scratcher attatched I don't see as how",cCret,cCret
                        DEFB "I can scratch anything !",cCret,cCret,cCret,cCret
                        DEFB " Just as well since I can't stand the",cCret,cCret
                        DEFB $86,$85," damn thing !",$00

PrintFailLp             LD A,$00                        ;
                        IN A,($FE)                      ;
                        OR $E0                          ;
                        INC A                           ;
                        JR NZ PrintFailLp               ;

PrintFailLp2            LD A,$00                        ;
                        IN A,($FE)                      ;
                        OR $E0                          ;
                        INC A                           ;
                        JR Z PrintFailLp2               ;

                        JP Boot                         ;

PrinterMenu             LD HL,AttrBase                  ;
                        LD DE,AT_PrinterMenu            ;
                        CALL SetTheAttrs                ;
                        CALL PrintStrFollow             ;
                        DEFB $86,"Driving the ZX Scratcher !",cCret,cCret,cCret
                        DEFB "1 Print the High Scores",cCret,cCret
                        DEFB "2 Print the Game Options",cCret,cCret,cCret
                        DEFB "8 Return to the main menu ",$00

PrinterMenuLp           LD A,$EF                        ;
                        IN A,($FE)                      ;
                        BIT 2,A                         ;
                        JP Z Boot                       ;

                        LD A,$F7                        ;
                        IN A,($FE)                      ;
                        BIT 0,A                         ;
                        JR Z PrintHSTable               ;

                        BIT 1,A                         ;
                        JR NZ PrinterMenuLp             ;

                        JP Boot                         ;

PrintHSTable            LD HL,$0000                     ;
                        LD (DScoreLSB),HL               ;
                        CALL ShowHighScores             ;
                        LD B,$C0                        ;
                        LD HL,ScreenBase                ;
PHST_Lp                 PUSH HL                         ;
                        PUSH BC                         ;
                        CALL Printer_1                  ;
                        POP BC                          ;
                        POP HL                          ;
                        INC H                           ;
                        LD A,H                          ;
                        AND $07                         ;
                        JR NZ PHST_LpNext               ;

                        LD A,L                          ;
                        ADD A,$20                       ;
                        LD L,A                          ;
                        CCF                             ;
                        SBC A,A                         ;
                        AND $F8                         ;
                        ADD A,H                         ;
                        LD H,A                          ;
PHST_LpNext             DJNZ PHST_Lp                    ;

                        LD A,$04                        ;
                        OUT ($FB),A                     ;
                        JP PrinterMenu                  ;

Printer_1               LD A,B                          ;
                        CP $03                          ;
                        SBC A,A                         ;
                        AND $02                         ;
                        OUT ($FB),A                     ;
                        LD D,A                          ;
Printer_Lp1             IN A,($FB)                      ;
                        ADD A,A                         ;
                        RET M                           ;

                        JR NC Printer_Lp1               ;

                        LD C,$20                        ;
Printer_Lp2             LD E,(HL)                       ;
                        INC HL                          ;
                        LD B,$08                        ;
Printer_Lp3             RL D                            ;
                        RL E                            ;
                        RR D                            ;
Printer_Lp4             IN A,($FB)                      ;
                        RRA                             ;
                        JR NC Printer_Lp4               ;

                        LD A,D                          ;
                        OUT ($FB),A                     ;
                        DJNZ Printer_Lp3                ;

                        DEC C                           ;
                        JR NZ Printer_Lp2               ;

                        RET                             ;

AT_GameFormat           DEFB $47,$40,$47,$02,$46,$3E,$47,$02;
                        DEFB $45,$3E,$47,$02,$07,$3E,$47,$02;
                        DEFB $44,$3E,$07,$80,$07,$40,$47,$02;
                        DEFB $43,$3E,$47,$02,$06,$3E,$00;
AT_SkillMenu            DEFB $47,$40,$47,$02,$46,$3E,$47,$02;
                        DEFB $45,$3E,$47,$02,$07,$3E,$47,$02;
                        DEFB $44,$3E,$47,$02,$45,$3E,$47,$02;
                        DEFB $46,$3E,$07,$40,$47,$02,$43,$3E;
                        DEFB $47,$02,$06,$3E,$00        ;
AT_GameVarMenu          DEFB $47,$40,$47,$02,$46,$3E,$47,$02;
                        DEFB $45,$3E,$47,$02,$07,$3E,$47,$02;
                        DEFB $44,$3E,$47,$02,$45,$3E,$40,$02;
                        DEFB $40,$3E,$07,$40,$47,$02,$43,$3E;
                        DEFB $47,$02,$06,$3E,$00        ;
AT_Instructions         DEFB $47,$80,$44,$40,$46,$80,$45,$20;
                        DEFB $07,$80,$07,$80,$07,$40,$43,$40;
                        DEFB $46,$04,$47,$04,$46,$0C,$00;.
AT_Controls             DEFB $47,$40,$47,$01,$46,$09,$45,$36;
                        DEFB $47,$01,$46,$09,$45,$36,$47,$01;.
                        DEFB $46,$09,$45,$36,$47,$01,$46,$09;
                        DEFB $45,$36,$47,$01,$46,$09,$45,$36;
                        DEFB $47,$01,$46,$09,$45,$36,$47,$01;.
                        DEFB $46,$09,$45,$56,$47,$01,$43,$0F;
                        DEFB $47,$02,$43,$0E,$07,$C0,$00;
AT_Joysticks            DEFB $47,$60,$47,$01,$46,$3F,$47,$01;
                        DEFB $46,$3F,$47,$01,$46,$3F,$47,$01;
                        DEFB $46,$3F,$47,$01,$46,$5F,$47,$01;
                        DEFB $43,$0F,$47,$02,$43,$0E,$07,$A0;
                        DEFB $45,$80,$00                ;
AT_SaveHS               DEFB $47,$60,$47,$01,$46,$5F,$47,$01;
                        DEFB $43,$5F,$45,$80,$45,$80,$47,$40;
                        DEFB $44,$80,$00                ;
AT_LoadHS               DEFB $47,$60,$47,$01,$46,$5F,$47,$01;
                        DEFB $43,$5F,$45,$80,$45,$40,$46,$40;
                        DEFB $44,$80,$00                ;
AT_PrinterMenu          DEFB $47,$60,$47,$01,$46,$3F,$47,$01;
                        DEFB $46,$5F,$47,$01,$43,$1F,$00;
AT_PrinterFail          DEFB $46,$80,$46,$80,$46,$20,$45,$80;
                        DEFB $45,$80,$00                ;

PlayGame                LD HL,(GameVector)              ;
                        CALL CallHL                     ;
                        LD (CurrScore),HL               ;
                        PUSH AF                         ;
                        XOR A                           ;
                        LD (CurX),A                     ;
                        LD (CurpY),A                    ;
                        LD HL,ScreenBase                ;
                        LD (CurY),HL                    ;
                        LD HL,ScreenBase                ;
                        LD DE,ScreenBase+1              ;
                        LD BC,$17FF                     ;
                        LD (HL),$00                     ;
                        LDIR                            ;
                        POP AF                          ;
                        CP $00                          ;
                        JR Z ShowFailed                 ;

                        CP $01                          ;
                        JR Z ShowSelfDestruct           ;

                        CALL PrintStrFollow             ;
                        DEFB $86,$86,$82,"Game Over",cCret,cCret,cCret
                        DEFB " You are victorious !",$00

                        JP ShowLiberated                ;

ShowSelfDestruct        CALL PrintStrFollow             ;
                        DEFB $86,$86,$82,"Game Over",cCret,cCret,cCret
                        DEFB " The Liar has self-destructed",$00

                        JR ShowScores                   ;

ShowFailed              CALL PrintStrFollow             ;
                        DEFB $86,$86,$82,"Game Over",cCret,cCret,cCret
                        DEFB " The Liar has been destroyed",$00

ShowScores              CALL PrintStrFollow             ;
                        DEFB " , and you",cCret," have been killed .",$00

ShowLiberated           CALL PrintStrFollow             ;
                        DEFB cCret,cCret," You liberated ",$00

                        LD HL,Map+$100                  ;
                        LD DE,$0000                     ;
SSL_Lp1                 BIT 7,(HL)                      ;
                        JR Z SSL_Neg                    ;

                        LD A,E                          ;
                        ADD A,$01                       ;
                        DAA                             ;
                        LD E,A                          ;
                        LD A,D                          ;
                        ADC A,$00                       ;
                        DAA                             ;
                        LD D,A                          ;
SSL_Neg                 INC L                           ;
                        JR NZ SSL_Lp1                   ;

                        EX DE,HL                        ;
                        LD A,H                          ;
                        OR A                            ;
                        JR NZ SSL_1                     ;

                        LD A,L                          ;
                        OR A                            ;
                        JR Z SSL_NoPlanets              ;

                        DEC A                           ;
                        JR Z SSL_OnePlanet              ;

SSL_1                   CALL PrintDec_LZ                ;
                        CALL PrintStrFollow             ;
                        DEFB " planets .",$00

                        JR SSL_AndScored                ;

SSL_NoPlanets           CALL PrintStrFollow             ;
                        DEFB "no planets .",0           ;
                        JR SSL_AndScored                ;

SSL_OnePlanet           CALL PrintStrFollow             ;
                        DEFB "1 planet .",$00

                        JR SSL_AndScored                ;

SSL_AndScored           CALL PrintStrFollow             ;
                        DEFB cCret,cCret," While doing this you scored ",$00

                        LD HL,(CurrScore)               ;
                        CALL PrintDec_LZ                ;
                        CALL PrintStrFollow             ;
                        DEFB "0 points .",$00

                        LD HL,AttrBuff                  ;
                        LD DE,AT_ShowResults            ;
                        CALL SetTheAttrs                ;
                        LD HL,AttrBuff                  ;
                        LD DE,AttrBase                  ;
SSL_AS_Lp1              LD A,(HL)                       ;
                        AND $40                         ;
                        LD (DE),A                       ;
                        INC DE                          ;
                        INC HL                          ;
                        LD A,D                          ;
                        CP $5B                          ;
                        JR NZ SSL_AS_Lp1                ;

                        LD B,8                          ;
SSL_AS_Lp2              CALL FindSomething              ;
                        CALL MediumPause                ;
                        DJNZ SSL_AS_Lp2                 ;

SSL_AS_Lp3              XOR A                           ;
                        IN A,($FE)                      ;
                        OR $E0                          ;
                        INC A                           ;
                        JR Z SSL_AS_Lp3                 ;

                        LD HL,$0000                     ;
CurrScore               EQU *-2                         ;
                        LD (DScoreLSB),HL               ;
                        CALL Unk6a                      ;
                        JP Boot                         ;

MediumPause             LD HL,$1600                     ;
MediumPauseLp           DEC HL                          ;
                        LD A,L                          ;
                        OR H                            ;
                        JR NZ MediumPauseLp             ;

                        RET                             ;

FindSomething           LD HL,AttrBase                  ;
                        LD DE,AttrBuff                  ;
FindLp                  LD A,(DE)                       ;
                        CP (HL)                         ;
                        JR Z Find1                      ;

                        INC (HL)                        ;
Find1                   INC HL                          ;
                        INC DE                          ;
                        LD A,H                          ;
                        CP $5B                          ;
                        JR NZ FindLp                    ;

                        RET                             ;

AT_ShowResults          DEFB $47,$60                    ;
                        DEFB $45,$40                    ;
                        DEFB $46,$40                    ;
                        DEFB $44,$40                    ;
                        DEFB $47,$40                    ;
                        DEFB $07,$80                    ;
                        DEFB $07,$80                    ;
                        DEFB $07,$80                    ;
                        DEFB $07,$20                    ;
                        DEFB 0                          ;

StartShowHighScores     LD HL,$0000                     ;
                        LD (DScoreLSB),HL               ;
Unk6a                   CALL ShowHighScores             ;
                        JP Init_IRQ                     ;

ShowHighScores          CALL PrintStrFollow             ;
                        DEFB cCLS,$00

                        XOR A                           ;
                        LD (UnkVar7),A                  ;
                        LD HL,AttrBase                  ;
                        LD DE,AT_HighScores             ;
                        CALL SetTheAttrs                ;
                        CALL PrintStrFollow             ;
                        DEFB $86,$86,$85,"Dark Star",cCret,cCret
                        DEFB $86,$86,$84,"Hall of Fame",cCret,cCret,$00

                        LD IX,HighScores                ;
                        LD A,"1"                        ;
ShowHS_Lp               CALL Unk9                       ;
                        INC A                           ;
                        CP "9"+1                        ;
                        JR NZ ShowHS_1                  ;

                        ADD A,$07                       ;
ShowHS_1                CP "H"                          ;
                        JR NZ ShowHS_Lp                 ;

                        LD A,(UnkVar7)                  ;
                        OR A                            ;
                        JP NZ GetHS_Entry               ;

                        CALL PrintStrFollow             ;
                        DEFB cCret,cCret,cCret,"Press SPACE to play or ENTER for options",$00
                        RET                             ;

GetHS_Entry             LD HL,(UnkVar8w)                ;
                        LD (CurY),HL                    ;
                        LD A,$0C                        ;
                        LD (CurX),A                     ;
                        LD HL,HS_Buffer                 ;
GetHS_Lp                CALL ReadKey                    ;
                        OR A                            ;
                        JR Z GetHS_Lp                   ;

                        CP cCret                        ;
                        JR Z GetHS_Done                 ;

                        CP cBS                          ;
                        JR Z GetHS_Delete               ;

                        LD E,A                          ;
                        LD D,$69                        ;
                        LD A,(DE)                       ;
                        LD D,A                          ;
                        LD A,(CurX)                     ;
                        ADD A,D                         ;
                        CP $CD                          ;
                        JR NC GetHS_Lp                  ;

                        LD A,E                          ;
                        LD (HL),A                       ;
                        INC HL                          ;
                        CALL Print                      ;
                        JR GetHS_Lp                     ;

GetHS_Done              CALL HSE_Check                  ;
                        LD (HL),$00                     ;
                        INC HL                          ;
                        LD A,(DScoreLSB)                ;
                        LD (HL),A                       ;
                        INC HL                          ;
                        LD A,(DScoreMSB)                ;
                        LD (HL),A                       ;
                        INC HL                          ;
                        LD DE,HS_Buffer                 ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD B,H                          ;
                        LD C,L                          ;
                        PUSH BC                         ;
                        LD HL,(UnkVar10w)               ;
                        LD DE,(UnkVar9w)                ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        PUSH HL                         ;
                        LD HL,(UnkVar10w)               ;
                        ADD HL,BC                       ;
                        EX DE,HL                        ;
                        LD HL,(UnkVar10w)               ;
                        POP BC                          ;
                        INC BC                          ;
                        LDDR                            ;
                        LD HL,HS_Buffer                 ;
                        LD DE,(UnkVar9w)                ;
                        POP BC                          ;
                        LDIR                            ;
                        CALL StartShowHighScores        ;
                        JP Init_IRQ                     ;

GetHS_Delete            LD DE,HS_Buffer                 ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        ADD HL,DE                       ;
                        JR Z GetHS_Lp                   ;

                        DEC HL                          ;
                        LD A,(HL)                       ;
                        PUSH HL                         ;
                        LD L,A                          ;
                        LD H,$69                        ;
                        LD A,(CurX)                     ;
                        SUB (HL)                        ;
                        LD (CurX),A                     ;
                        LD H,A                          ;
                        LD A,L                          ;
                        CALL Print                      ;
                        LD A,H                          ;
                        LD (CurX),A                     ;
                        POP HL                          ;
                        JP GetHS_Lp                     ;

HSE_Check               LD DE,HS_Buffer                 ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        JR NZ HSE_CheckLength           ;

                        LD HL,sSomeone                  ;
                        LD DE,HS_Buffer                 ;
                        LD BC,$0007                     ;
                        LDIR                            ;
                        EX DE,HL                        ;
                        RET                             ;

sSomeone                DEFB "Someone"

HSE_CheckLength         LD A,L                          ;
                        ADD HL,DE                       ;
                        CP $60                          ;
                        JR C HSE_NotTooLong             ;

                        LD HL,sEasyRepeat               ;
                        LD DE,HS_Buffer                 ;
                        LD BC,$0019                     ;
                        LDIR                            ;
                        EX DE,HL                        ;
                        RET                             ;

sEasyRepeat             DEFB "It's easier with repeat !"

HSE_NotTooLong          LD IX,HS_sCompares              ;
                        LD IY,HS_sReplaces              ;
                        LD (HL),$00                     ;
                        PUSH HL                         ;
HSE_Check1              PUSH IX                         ;
                        LD HL,HS_Buffer                 ;
HSE_CheckLp             LD A,(HL)                       ;
                        CP $20                          ;
                        INC HL                          ;
                        JR Z HSE_CheckLp                ;

                        OR A                            ;
                        JR Z HSE_Check2                 ;

                        CALL Make_LC                    ;
                        CP (IX)                         ;
                        INC IX                          ;
                        JR Z HSE_CheckLp                ;

                        DEC IX                          ;
HSE_Check2              LD A,(IX)                       ;
                        OR A                            ;
                        POP IX                          ;
                        JR Z Unk8                       ;

HSE_Check3              LD A,(IX)                       ;
                        INC IX                          ;
                        OR A                            ;
                        JR NZ HSE_Check3                ;

HSE_Check4              LD A,(IY)                       ;
                        INC IY                          ;
                        OR A                            ;
                        JR NZ HSE_Check4                ;

                        LD A,(IX)                       ;
                        INC A                           ;
                        JR NZ HSE_Check1                ;

                        POP HL                          ;
                        RET                             ;

Make_LC                 CP $5B                          ;
                        RET NC                          ;

                        CP $41                          ;
                        RET C                           ;

                        ADD A,$20                       ;
                        RET                             ;

Unk8                    PUSH IY                         ;
                        POP DE                          ;
                        POP AF                          ;
                        LD HL,HS_Buffer                 ;
Unk8a                   LD A,(DE)                       ;
                        OR A                            ;
                        RET Z                           ;

                        LD (HL),A                       ;
                        INC DE                          ;
                        INC HL                          ;
                        JR Unk8a                        ;

HS_sCompares            DEFB "crystal",$00
                        DEFB "sex",$00
                        DEFB "fuckoff",$00
                        DEFB "cheesecake",$00
                        DEFB "spectrum",$00
                        DEFB "tonything",$00
                        DEFB "joystickjim",$00
                        DEFB "s.brattel",$00
                        DEFB "design-design",$00
                        DEFB "msx",$00
                        DEFB "c64",$00
                        DEFB "t.bridge",$00
                        DEFB "tony",$00
                        DEFB "ultimate",$00
                        DEFB "jetsetwilly",$00
                        DEFB "starblitz",$00
                        DEFB "defenda",$00
                        DEFB "invasionofthe",$00
                        DEFB "rommels",$00
                        DEFB "matthewsmith",$00
                        DEFB "pinback",$00
                        DEFB "help",$00
                        DEFB "martinsmith",$00
                        DEFB "motty",$00
                        DEFB "lynn",$00
                        DEFB "linda",$00
                        DEFB "shit",$00
                        DEFB "c&vg",$00
                        DEFB "kiethcampbell",$00
                        DEFB "mash",$00
                        DEFB "spectacle",$00
                        DEFB "robin",$00
                        DEFB "meb",$00
                        DEFB "ql",$00
                        DEFB $FF

HS_sReplaces            DEFB "Design-Design Software",$00
                        DEFB "Sex...don't talk to me about sex .",$00
                        DEFB "Go and swivel !",$00
                        DEFB "Mott won't make 'em anymore !",$00
                        DEFB "Miles better than the MSX crap!",$00
                        DEFB "Hi there man",$00
                        DEFB "who ?",$00
                        DEFB "The real virgin programmer !",$00
                        DEFB "What a what a silly silly name !",$00
                        DEFB "Extremely crappy JAPANESE shit !",$00
                        DEFB "Couldn't begin to do this !",$00
                        DEFB "Want yer hobbit ?",$00
                        DEFB "Which Tony ? (^ = Tony Thing)",$00
                        DEFB "Nice shapes shame about the game !",$00
                        DEFB "Bug-ridden game of the decade !",$00
                        DEFB "You've got to be f.....g kidding !",$00
                        DEFB "So tediously ssllloowwww !",$00
                        DEFB "Too fast for you CRASH ?",$00
                        DEFB "What a slow tedious game !",$00
                        DEFB "Major Wally",$00
                        DEFB "Want yer beachball ?",$00
                        DEFB $22,"NI",$22," ",$22,"NI WOM",$22," ",$22,"PETANG",$22,$00
                        DEFB "MY GOD ! The herring exploded !",$00
                        DEFB "The incredible shrinking sulk !",$00
                        DEFB "Hello lynn !",$00
                        DEFB "Nibble ! Nibble !",$00
                        DEFB "You've typed enough in already !",$00
                        DEFB "C&UG Complete and Utter Garbage !",$00
                        DEFB "You're a JERK Campbell etc .... !",$00
                        DEFB "ZAP !",$00,"Yes we are mad aren't we ?",$00
                        DEFB "Happy Birthday !",$00
                        DEFB "MEH",$00
                        DEFB "Quite Late ? Queue Longer ?",$00
                        DEFB $FF

Unk9                    PUSH AF                         ;
                        CALL Print                      ;
                        CALL PrintSP                    ;
                        PUSH IX                         ;
                        POP HL                          ;
                        LD A,(UnkVar7)                  ;
                        OR A                            ;
                        JR NZ Unk9a                     ;

Unk9Lp                  LD A,(HL)                       ;
                        OR A                            ;
                        INC HL                          ;
                        JR NZ Unk9Lp                    ;

                        LD A,(HL)                       ;
                        INC HL                          ;
                        LD H,(HL)                       ;
                        LD L,A                          ;
                        LD DE,(DScoreLSB)               ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        JR NC Unk9a                     ;

                        LD A,$01                        ;
                        LD (UnkVar7),A                  ;
                        LD HL,(CurY)                    ;
                        LD (UnkVar8w),HL                ;
                        LD (UnkVar9w),IX                ;
                        EX DE,HL                        ;
                        JR Unk10a                       ;

Unk9a                   LD A,(IX)                       ;
                        OR A                            ;
                        INC IX                          ;
                        JR Z Unk10                      ;

                        CALL Print                      ;
                        JR Unk9a                        ;

Unk10                   LD L,(IX)                       ;
                        INC IX                          ;
                        LD H,(IX)                       ;
                        INC IX                          ;
                        LD (UnkVar10w),IX               ;
Unk10a                  LD A,$D3                        ;
                        LD (CurX),A                     ;
                        CALL PrintDec_LS                ;
                        CALL PrintStrFollow             ;
                        DEFB "0",cCret,$00

                        POP AF                          ;
                        RET                             ;

Unk10b                  INC IX                          ;
L8B9A                   CALL PrintSP                    ;
                        DJNZ L8B9A                      ;

                        JR Unk10                        ;

PrintSP                 PUSH AF                         ;
                        LD A,$20                        ;
                        CALL Print                      ;
                        POP AF                          ;
                        RET                             ;

Print80                 PUSH AF                         ;
                        LD A,$80                        ;
                        CALL Print                      ;
                        POP AF                          ;
                        RET                             ;

PrintDec_LS             LD C,$00                        ;
                        LD B,4                          ;
PDLS0                   CALL PDLS1                      ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        DJNZ PDLS0                      ;

                        RET                             ;

PDLS1                   LD A,H                          ;
                        RRCA                            ;
                        RRCA                            ;
                        RRCA                            ;
                        RRCA                            ;
                        AND $0F                         ;
                        JR Z PDLS2                      ;

                        INC C                           ;
                        OR $30                          ;
                        JP Print                        ;

PDLS2                   LD A,C                          ;
                        OR A                            ;
                        JR Z PrintSP                    ;

                        LD A,$30                        ;
                        JP Print                        ;

PrintDec_LZ             LD C,$00                        ;
                        LD B,4                          ;
PDLZ0                   CALL PDLZ1                      ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        DJNZ PDLZ0                      ;

                        RET                             ;

PDLZ1                   LD A,H                          ;
                        RRCA                            ;
                        RRCA                            ;
                        RRCA                            ;
                        RRCA                            ;
                        AND $0F                         ;
                        JR Z PDLZ2                      ;

                        INC C                           ;
                        OR $30                          ;
                        JP Print                        ;

PDLZ2                   LD A,C                          ;
                        OR A                            ;
                        RET Z                           ;

                        LD A,$30                        ;
                        JP Print                        ;

ShowMainMenu            CALL PrintStrFollow             ;
                        DEFB cCLS,$00
                        LD HL,AttrBase                  ;
                        LD DE,AT_MainMenu               ;
                        CALL SetTheAttrs                ;
                        CALL PrintStrFollow             ;
                        DEFB $86,$86,$85,"Dark Star",cCret,cCret
                        DEFB " 1  Play the game",cCret,cCret
                        DEFB " 2  Read the instructions",cCret,cCret,cCret
                        DEFB " 3  Define the playing keys",cCret,cCret
                        DEFB " 4  Change the game",cCret,cCret,cCret
                        DEFB " 5  Load an old Hi-score table and keys",cCret,cCret
                        DEFB " 6  Save the current Hi-scores and keys",cCret,cCret
                        DEFB " 7  Print the High-Scores",cCret,cCret,cCret,cCret,cCret,cCret
                        DEFB "Written by Simon Brattel",cCret,"(c) Design Design Software",$00

                        RET                             ;


AT_MainMenu             DEFB $47,$40,$47,$02,$46,$3E,$47,$02;
                        DEFB $46,$3E,$47,$22,$45,$3E,$47,$02;
                        DEFB $45,$3E,$47,$22,$44,$3E,$47,$02;
                        DEFB $44,$3E,$47,$02,$44,$3E,$47,$22;
                        DEFB $43,$1E,$43,$80,$00        ;

AT_HighScores           DEFB $47,$80,$44,$01,$07,$19,$45,$06;
                        DEFB $44,$01,$07,$19,$45,$06,$44,$01;
                        DEFB $07,$19,$45,$06,$44,$01,$07,$19;
                        DEFB $45,$06,$44,$01,$07,$19,$45,$06;
                        DEFB $44,$01,$07,$19,$45,$06,$44,$01;
                        DEFB $07,$19,$45,$06,$44,$01,$07,$19;
                        DEFB $45,$06,$44,$01,$07,$19,$45,$06;
                        DEFB $44,$01,$07,$19,$45,$06,$44,$01;
                        DEFB $07,$19,$45,$06,$44,$01,$07,$19;
                        DEFB $45,$06,$44,$01,$07,$19,$45,$06;
                        DEFB $44,$01,$07,$19,$45,$06,$44,$01;
                        DEFB $07,$19,$45,$06,$44,$01,$07,$19;
                        DEFB $45,$06,$44,$01,$07,$19,$45,$06;
                        DEFB $44,$01,$07,$19,$45,$06,$44,$01;
                        DEFB $07,$19,$45,$06,$46,$04,$07,$05;
                        DEFB $46,$07,$07,$05,$46,$0B,$00;

SetTheAttrs             LD A,(DE)                       ;
                        OR A                            ;
                        RET Z                           ;

                        INC DE                          ;
                        LD C,A                          ;
                        LD A,(DE)                       ;
                        INC DE                          ;
                        LD B,A                          ;
STA_Lp                  LD (HL),C                       ;
                        INC HL                          ;
                        DJNZ STA_Lp                     ;

                        JR SetTheAttrs                  ;

Unk11                   INC D                           ;
                        EX AF,AF'                       ;
                        DEC D                           ;
                        DI                              ;
                        LD A,$09                        ;
                        OUT ($FE),A                     ;
                        LD HL,Unk12                     ;
                        PUSH HL                         ;
                        IN A,($FE)                      ;
                        RRA                             ;
                        AND $20                         ;
                        LD C,A                          ;
                        CP A                            ;
Unk11a                  RET NZ                          ;

Unk11b                  CALL Unk11p                     ;
                        JR NC Unk11a                    ;

                        LD HL,$0415                     ;
Unk11c                  DJNZ Unk11c                     ;

                        DEC HL                          ;
                        LD A,H                          ;
                        OR L                            ;
                        JR NZ Unk11c                    ;

                        CALL Unk11o                     ;
                        JR NC Unk11a                    ;

Unk11d                  LD B,$9C                        ;
                        CALL Unk11o                     ;
                        JR NC Unk11a                    ;

                        LD A,$C6                        ;
                        CP B                            ;
                        JR NC Unk11b                    ;

                        INC H                           ;
                        JR NZ Unk11d                    ;

Unk11e                  LD B,$C9                        ;
                        CALL Unk11p                     ;
                        JR NC Unk11a                    ;

                        LD A,B                          ;
                        CP $D4                          ;
                        JR NC Unk11e                    ;

                        CALL Unk11p                     ;
                        RET NC                          ;

                        LD H,$00                        ;
                        LD B,$B0                        ;
                        JR Unk11m                       ;

Unk11f                  EX AF,AF'                       ;
                        JR NZ Unk11h                    ;

                        JR NC Unk11g                    ;

Unk11g                  LD (IX),L                       ;
                        JR Unk11i                       ;

Unk11h                  RL C                            ;
                        XOR L                           ;
                        RET NZ                          ;

                        LD A,C                          ;
                        RRA                             ;
                        LD C,A                          ;
                        INC DE                          ;
                        JR Unk11k                       ;

Unk11i                  INC IX                          ;
Unk11k                  DEC DE                          ;
                        EX AF,AF'                       ;
                        LD B,$B2                        ;
Unk11m                  LD L,$01                        ;
Unk11n                  CALL Unk11o                     ;
                        RET NC                          ;

                        LD A,$CB                        ;
                        CP B                            ;
                        RL L                            ;
                        LD B,$B0                        ;
                        JP NC Unk11n                    ;

                        LD A,H                          ;
                        XOR L                           ;
                        LD H,A                          ;
                        LD A,D                          ;
                        OR E                            ;
                        JR NZ Unk11f                    ;

                        LD A,H                          ;
                        CP $01                          ;
                        RET                             ;

Unk11o                  CALL Unk11p                     ;
                        RET NC                          ;

Unk11p                  LD A,$16                        ;
Unk11q                  DEC A                           ;
                        JR NZ Unk11q                    ;

                        OR A                            ;
Unk11r                  INC B                           ;
                        RET Z                           ;

                        LD A,$BF                        ;
                        IN A,($FE)                      ;
                        RRA                             ;
                        JR NC Unk12b                    ;

                        XOR C                           ;
                        AND $20                         ;
                        JR Z Unk11r                     ;

                        LD A,C                          ;
                        XOR $F9                         ;
                        LD C,A                          ;
                        AND $07                         ;
                        OR $08                          ;
                        OUT ($FE),A                     ;
                        SCF                             ;
                        RET                             ;


Unk12                   PUSH AF                         ;
                        LD A,$00                        ;
                        OUT ($FE),A                     ;
                        LD A,$BF                        ;
                        IN A,($FE)                      ;
                        RRA                             ;
                        JR NC Unk12a                    ;

                        POP AF                          ;
                        RET                             ;

Unk12b                  JP Boot                         ;

Unk12a                  LD A,$FF                        ;
                        POP AF                          ;
                        SCF                             ;
                        RET                             ;


Unk13                   LD HL,Unk12                     ;
                        PUSH HL                         ;
                        LD HL,$1F80                     ;
                        BIT 7,A                         ;
                        JR Z Unk13a                     ;

                        LD HL,$0C98                     ;
Unk13a                  EX AF,AF'                       ;
                        INC DE                          ;
                        DEC IX                          ;
                        DI                              ;
                        LD A,$01                        ;
                        LD B,A                          ;
Unk13b                  DJNZ Unk13b                     ;

                        OUT ($FE),A                     ;
                        XOR $09                         ;
                        LD B,$A4                        ;
                        DEC L                           ;
                        JR NZ Unk13b                    ;

                        DEC B                           ;
                        DEC H                           ;
                        JP P Unk13b                     ;

                        LD B,$2F                        ;
Unk13c                  DJNZ Unk13c                     ;

                        OUT ($FE),A                     ;
                        LD A,$09                        ;
                        LD B,$37                        ;
Unk13d                  DJNZ Unk13d                     ;

                        OUT ($FE),A                     ;
                        LD BC,$3808                     ;
                        EX AF,AF'                       ;
                        LD L,A                          ;
                        JP Unk13g                       ;

Unk13e                  LD A,D                          ;
                        OR E                            ;
                        JR Z Unk13h                     ;

                        LD L,(IX)                       ;
Unk13f                  LD A,H                          ;
                        XOR L                           ;
Unk13g                  LD H,A                          ;
                        LD A,$01                        ;
                        SCF                             ;
                        JP Unk13m                       ;

Unk13h                  LD L,H                          ;
                        JR Unk13f                       ;

Unk13i                  LD A,C                          ;
                        BIT 7,B                         ;
Unk13j                  DJNZ Unk13j                     ;

                        JR NC Unk13l                    ;

                        LD B,$42                        ;
Unk13k                  DJNZ Unk13k                     ;

Unk13l                  OUT ($FE),A                     ;
                        LD B,$3E                        ;
                        JR NZ Unk13i                    ;

                        DEC B                           ;
                        XOR A                           ;
                        INC A                           ;
Unk13m                  RL L                            ;
                        JP NZ Unk13j                    ;

                        DEC DE                          ;
                        INC IX                          ;
                        LD B,$31                        ;
                        LD A,$BF                        ;
                        IN A,($FE)                      ;
                        RRA                             ;
                        RET NC                          ;

                        LD A,D                          ;
                        INC A                           ;
                        JP NZ Unk13e                    ;

                        LD B,$38                        ;
Unk13n                  DJNZ Unk13n                     ;

                        RET                             ;

Init_IRQ                LD HL,IRQ_VectorTab             ;
                        LD DE,IRQ_VectorTab + 1         ;
                        LD BC,$0100                     ;
                        LD (HL),$90                     ;
                        LDIR                            ;
                        LD A,high IRQ_VectorTab         ;
                        LD I,A                          ;
                        IM 2                            ;
TonyWaitLp              EI                              ;
                        HALT                            ;
                        LD A,$BF                        ;
                        IN A,($FE)                      ;
                        BIT 0,A                         ;
                        JR Z TonyExit                   ;

                        LD A,$7F                        ;
                        IN A,($FE)                      ;
                        BIT 0,A                         ;
                        LD ($0000),A                    ;
                        JR NZ TonyWaitLp                ;

                        DI                              ;
                        XOR A                           ;
                        LD I,A                          ;
                        JP PlayGame                     ;

TonyExit                DI                              ;
                        XOR A                           ;
                        LD I,A                          ;
                        JP Boot                         ;

                        JP Boot                         ;

; Tony Code here
                        ORG $9090
                        LD B,$9D                        ;
L9092                   LD A,$00                        ;
                        INC HL                          ;
                        PUSH IX                         ;
                        POP IX                          ;
                        DJNZ L9092                      ;

                        LD HL,$0000                     ;
                        LD HL,$0000                     ;
                        LD HL,$0000                     ;
                        LD HL,$0000                     ;
                        LD BC,$02FE                     ;
                        LD DE,$0000                     ;
                        LD HL,$0700                     ;
                        LD A,$00                        ;
                        CALL TonyLp2                    ;
                        LD HL,($0000)                   ;
                        LD HL,($0000)                   ;
                        LD HL,$0000                     ;
                        LD BC,$01FE                     ;
                        LD DE,$0000                     ;
                        LD HL,$0707                     ;
                        LD A,$00                        ;
                        CALL TonyLp2                    ;
                        LD HL,($0000)                   ;
                        LD HL,($0000)                   ;
                        LD HL,$0000                     ;
                        LD BC,$03FE                     ;
                        LD DE,$0700                     ;
                        LD HL,$0101                     ;
                        LD A,$00                        ;
                        CALL TonyLp2                    ;
                        LD HL,($0000)                   ;
                        LD HL,($0000)                   ;
                        LD HL,$0000                     ;
                        LD BC,$05FE                     ;
                        LD DE,$0700                     ;
                        LD HL,$0601                     ;
                        LD A,$00                        ;
                        CALL TonyLp2                    ;
                        LD HL,($0000)                   ;
                        LD HL,($0000)                   ;
                        LD HL,$0000                     ;
                        LD BC,$03FE                     ;
                        LD DE,$0700                     ;
                        LD HL,$0607                     ;
                        LD A,$00                        ;
                        CALL TonyLp2                    ;
                        LD HL,($0000)                   ;
                        LD HL,($0000)                   ;
                        LD HL,$0000                     ;
                        LD BC,$02FE                     ;
                        LD DE,$0707                     ;
                        LD HL,$0600                     ;
                        LD A,$00                        ;
                        CALL TonyLp2                    ;
                        LD HL,($0000)                   ;
                        LD HL,($0000)                   ;
                        LD HL,$0000                     ;
                        LD BC,$03FE                     ;
                        LD DE,$0707                     ;
                        LD HL,$0000                     ;
                        LD A,$00                        ;
                        CALL TonyLp2                    ;
                        LD HL,($0000)                   ;
                        LD HL,($0000)                   ;
                        LD HL,$0000                     ;
                        LD BC,$03FE                     ;
                        LD DE,$0000                     ;
                        LD HL,$0000                     ;
                        LD A,$00                        ;
                        CALL TonyLp2                    ;
                        RETI                            ;

TonyLp1                 LD IX,($0000)                   ;
                        LD IX,($0000)                   ;
                        LD IX,($0000)                   ;
                        LD IX,($0000)                   ;
                        LD IX,($0000)                   ;
                        LD IX,$0000                     ;
TonyLp2                 OUT (C),E                       ;
                        OUT (C),D                       ;
                        OUT (C),L                       ;
                        OUT (C),H                       ;
                        OUT (C),L                       ;
                        OUT (C),D                       ;
                        OUT (C),E                       ;
                        OUT (C),A                       ;
                        DEC B                           ;
                        JP NZ TonyLp1                   ;

                        NOP                             ;
                        NOP                             ;
                        RET                             ;
; Fake start
StartUsUp               ld a,r
                        and $7F
                        ld r,a
                        jp Reset
; IRQ table here
                        ORG $9200
IRQ_VectorTab           DS $101,$90

AttrBuff                EQU $FC00                       ;

